3 # zgrep -- a wrapper around a grep program that decompresses files as needed
4 # Adapted from a version sent by Charles Levert <charles@comm.polymtl.ca>
6 # Copyright (C) 1998, 2001-2002, 2006-2007, 2009-2015 Free Software
9 # Copyright (C) 1993 Jean-loup Gailly
11 # This program is free software; you can redistribute it and/or modify
12 # it under the terms of the GNU General Public License as published by
13 # the Free Software Foundation; either version 3 of the License, or
14 # (at your option) any later version.
16 # This program is distributed in the hope that it will be useful,
17 # but WITHOUT ANY WARRANTY; without even the implied warranty of
18 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
19 # GNU General Public License for more details.
21 # You should have received a copy of the GNU General Public License along
22 # with this program; if not, write to the Free Software Foundation, Inc.,
23 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
27 --__bindir) bindir
=${2?}; shift; shift;;
31 grep='${GREP-'\''@GREP@'\''}'
33 version
='zgrep (gzip) @VERSION@
34 Copyright (C) 2010-2015 Free Software Foundation, Inc.
35 This is free software. You may redistribute copies of it under the terms of
36 the GNU General Public License <http://www.gnu.org/licenses/gpl.html>.
37 There is NO WARRANTY, to the extent permitted by law.
39 Written by Jean-loup Gailly.'
41 usage
="Usage: $0 [OPTION]... [-e] PATTERN [FILE]...
42 Look for instances of PATTERN in the input FILEs, using their
43 uncompressed contents if they are compressed.
45 OPTIONs are the same as for 'grep', except that the following 'grep'
46 options are not supported: --dereference-recursive (-R), --directories (-d),
47 --exclude, --exclude-from, --exclude-dir, --include, --null (-Z),
48 --null-data (-z), and --recursive (-r).
50 Report bugs to <bug-gzip@gnu.org>."
52 # sed script to escape all ' for the shell, and then (to handle trailing
53 # newlines correctly) append ' to the last line.
55 s/'\''/'\''\\'\'''\''/g
61 files_without_matches
=0
65 while test $# -ne 0; do
71 (-[0123456789EFGHIKLPRTUVZabchilnoqrsuvwxyz
]*[!0123456789]*)
72 arg2
=-\'$
(expr "X$option" : 'X-.[0-9]*\(.*\)' |
sed "$escape")
73 eval "set -- $arg2 "'${1+"$@"}'
74 option
=$
(expr "X$option" : 'X\(-.[0-9]*\)');;
75 (--binary-*=* |
--[lm
]a
*=* |
--reg*=*)
77 (-[ABCDXdefm
] | binary-
* |
--file |
--[lm
]a
* |
--reg*)
78 case ${1?"$option option requires an argument"} in
80 optarg
=" '"$
(printf '%s\n' "$1" |
sed "$escape");;
86 optarg
=" '"$
(expr "X$option" : 'X-f\(.*\)' |
sed "$escape")
89 optarg
=" '"$
(expr "X$option" : 'X-f\(.*\)')\'
92 optarg
=" '"$
(expr "X$option" : 'X--file=\(.*\)' |
sed "$escape")
95 optarg
=" '"$
(expr "X$option" : 'X--file=\(.*\)')\'
104 operands
="$operands '"$
(printf '%s\n' "$option" |
sed "$escape");;
106 operands
="$operands '$option'";;
108 ${POSIXLY_CORRECT+break}
113 (-[drRzZ
] |
--di* |
--exc* |
--inc* |
--rec* |
--nu*)
114 printf >&2 '%s: %s: option not supported\n' "$0" "$option"
119 # The pattern is coming from a file rather than the command-line.
120 # If the file is actually stdin then we need to do a little
121 # magic, since we use stdin to pass the gzip output to grep.
122 # Turn the -f option into an -e option by copying the file's
123 # contents into OPTARG.
125 (" '-'" |
" '/dev/stdin'" |
" '/dev/fd/0'")
127 optarg
=" '"$
(sed "$escape") ||
exit 2;;
130 (--h |
--he |
--hel |
--help)
131 echo "$usage" ||
exit 2
133 (-H |
--wi |
--wit |
--with |
--with- |
--with-f |
--with-fi \
134 |
--with-fil |
--with-file |
--with-filen |
--with-filena |
--with-filenam \
138 (-l |
--files-with-*)
139 files_with_matches
=1;;
140 (-L |
--files-witho*)
141 files_without_matches
=1;;
144 (-V |
--v |
--ve |
--ver |
--vers |
--versi |
--versio |
--version)
145 echo "$version" ||
exit 2
151 option
=\'$
(printf '%s\n' "$option" |
sed "$escape");;
156 grep="$grep $option$optarg"
159 eval "set -- $operands "'${1+"$@"}'
161 if test $have_pat -eq 0; then
162 case ${1?"missing pattern; try \`$0 --help' for help"} in
164 grep="$grep -- '"$
(printf '%s\n' "$1" |
sed "$escape");;
166 grep="$grep -- '$1'";;
171 if test $# -eq 0; then
180 # Fail if gzip or grep (or sed) fails.
183 (gzip -cdfq -- "$i" 5>&-; echo $?
>&5) 3>&- |
184 if test $files_with_matches -eq 1; then
185 eval "$grep" >/dev
/null
&& { printf '%s\n' "$i" ||
exit 2; }
186 elif test $files_without_matches -eq 1; then
187 eval "$grep" >/dev
/null ||
{
189 if test $r -eq 1; then
190 printf '%s\n' "$i" || r
=2
194 elif test $with_filename -eq 0 &&
195 { test $# -eq 1 ||
test $no_filename -eq 1; }; then
200 '* |
*'&'* |
*'\'* | *'|
'*)
201 i=$(printf '%s
\n' "$i" |
208 sed_script="s|^|$i:|"
210 # Fail if grep or sed fails.
213 (eval "$grep" 4>&-; echo $? >&4) 3>&- | sed "$sed_script" >&3 4>&-
216 test 1 -lt $r && exit $r || exit 2
221 # Ignore gzip status 2, as it is just a warning.
222 # gzip status 1 is an error, like grep status 2.
223 test $gzip_status -eq 2 && gzip_status=0
224 test $gzip_status -eq 1 && gzip_status=2
226 # Use the more serious of the grep and gzip statuses.
227 test $r -lt $gzip_status && r=$gzip_status
229 # Exit immediately on software configuration error.
230 test 126 -le $r && exit $r
232 # Accumulate the greatest status, except consider 0 to be greater than 1.
233 if test $r -le 1 && test $res -le 1; then